%define rname spank-nvidia
Name:		slurm-%{rname}
Version:	0.1
Release:	1%{?dist}.4
Summary:	Slurm spank plugin to allow use of mps and setting of nvidia gpu modes
License:	Unknown

Source0:	nvidia_spank.c
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildRequires:	slurm-devel cuda-nvml-devel-11-0
Requires:	slurm

%description
This is a SPANK plugin for Slurm to allow users to set nvidia process mode, accounting and mps.

%prep
%setup -T -c -n %{rname}
cp %{SOURCE0} .

%build
gcc -I/usr/local/cuda-11.0/targets/x86_64-linux/include -fPIC -shared -g -o nvidia_spank.so nvidia_spank.c -lnvidia-ml -L/usr/local/cuda-11.0/targets/x86_64-linux/lib/stubs

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_libdir}/slurm %{buildroot}/etc/slurm/plugstack.conf.d
install -m 755 nvidia_spank.so %{buildroot}%{_libdir}/slurm
echo "optional %{_libdir}/slurm/nvidia_spank.so" > %{buildroot}/etc/slurm/plugstack.conf.d/nvidia.conf

%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%{_libdir}/slurm/nvidia_spank.so
%dir /etc/slurm/plugstack.conf.d
/etc/slurm/plugstack.conf.d/nvidia.conf

%changelog
* Mon Oct 09 2017 Josko Plazonic <plazonic@princeton.edu> 0.1-1.sdl6.1
- initial build
